.bp
.so include.n
.pn 1
.fo ``-C.%-``
.po 
.nh
.ls 2
.nr s 11
.sp 2
.ce
Appendix C
.ce
Error Messages
.he ``Error Messages``
.pp
Error messages in muTENSOR protect the user from invalid arguments
and illegal operations. Each muTENSOR error message consists of the
words ERROR or WARNING, followed by a cryptic explanation of the
problem, and one or more of the parameters or values that are in
error. In the error message listing below, these parameters are
enclosed in angle brackets.
A warning message indicates that the function which
gave the message may attempt to continue, although many functions
simply exit with FALSE. A fatal error causes a THROW to the top level
driver, and aborts all pending operations. 
.sp 3
.br
.in 3
.sp 1
.ne 3
.ti 0
NOTE: vmem file <file> exists.
.br
This message will only appear at the system startup if the default
virtual memory file exists and is not corrupted. It is purely informational.
.sp 1
.ne 3
.ti 0
WARNING: DIV requires vector: <tnsr> (from DIV)
.br
The function \*BDIV\fP can only compute the divergence of a vector.
.sp 1
.ne 3
.ti 0
ERROR: Lie requires a vector: <vec> (from LIE)
.br
The function \*BLIE\fP requires a vector in order to compute the directional
derivative. 
.sp 1
.ne 3
.ti 0
WARNING: bad IMPLICIT value <implicit> <tnsr> (from MKTNSR)
.br
The \*BIMPLICIT\fP parameter <implicit> input to \*BMKTNSR\fP for the 
construction of the object <name> is invalid. It is either not an
atom, not an integer or, if not <name>, then it is not the name of 
another indexed object, or the \*BCONCOV\fP list of the object does not
match the \*BCONCOV\fP list of <name>. 
.sp 1
.ne 3
.ti 0
ERROR: bad block size: <block size>, <symmetry> (from CHKSYM)
.br
The block-size <block-size> of the independent symmetry 
<symmetry> is not an integer.
.sp 1
.ne 3
.ti 0
ERROR: bad concov element: <n> (from GETINDICES)
.br
The indicated integer from a \*BCONCOV\fP list is not one of the allowed
values 0, 1, 2, 3, or 4. 
.sp 1
.ne 3
.ti 0
ERROR: bad connection: <name> (from SETCON)
.br
The object <name> is not a valid connection. It is is either not of type
\*BCONNECTION\fP or its first index is not contravariant.
.sp 1
.ne 3
.ti 0
ERROR: bad derivative operator (from DERIVPARSE)
.br
The parser has encountered three | in a row.
.sp 1
.ne 3
.ti 0
ERROR: bad input: <exp> (from <function>)
.br
The expression <exp> input to the routine <function> was not an
indexed object. 
.sp 1
.ne 3
.ti 0
ERROR: bad metric: <name> (from SETMET)
.br
The object <name> is not a valid metric: its type is 
not \*BMETRIC\fP or it does not have two covariant indices. The metric 
inverse cannot be used in the \*BCURRENTMETRIC\fP list.
.sp 1
.ne 3
.ti 0
ERROR: bad pointer: <pointer> <symmetry> (from CHKSYM)
.br
The pointer <pointer> in the independent symmetry <symmetry> is
not a positive non-zero integer. 
.sp 1
.ne 3
.ti 0
ERROR: cannot assign to <name> (from COLONPARSE)
.br
The object <name> to the left of a `::' operator is not a valid 
indexed object, and cannot be assigned.
.sp 1
.ne 3
.ti 0
ERROR: cannot create conjugate <name> (from MKCONJ)
.br
The object <name> is indexed and protected. \*BMKCONJ\fP wishes to use <name>
for a conjugate object, but is unable to. <name> will be of the form
<basename>#CNJ.
.sp 1
.ne 3
.ti 0
WARNING: cannot create object: <name> (from MKTNSR)
.br
The object <name> is already indexed and is also delete-protected.
.sp 1
.ne 3
.ti 0
WARNING: cannot open save file: <file> (from SAVEIC)
.br
The file specified in a \*BSAVEI\fP or \*BSAVEC\fP function call cannot be opened.
.sp 1
.ne 3
.ti 0
ERROR: cannot symmetrize more than 4 indices
.br
A symmetrization operation extending over more than 4 indices
has been attempted. 
.sp 1
.ne 3
.ti 0
WARNING: can't put gradient on non-atomic form: <form> (from GRADV)
.br
\*BGRADV\fP can only place gradients on atoms, the form given is non-atomic.
.sp 1
.ne 3
.ti 0
ERROR: connection does not exist: <n> (from GETCON)
.br
The connection coefficient of type <n> does not exist (n \(eq 1, 2, 3).
.sp 1
.ne 3
.ti 0
WARNING: coord-indice  mis-match:  <coords>, <indiceten> (from MKTNSR)
.br
The tensor index run, stored on the global variable \*BINDICETEN\fP does
not match the length of the current system coordinates, stored on the
global variable \*BCOORDS\fP.
.sp 1
.ne 3
.ti 0
WARNING: could not execute manual.exe (from HELP)
.br
The manual reading program is not in the same directory as muTENSOR or
there is insufficient memory to run the program.
.sp 1
.ne 3
.ti 0
ERROR: derivative op illegal in index: <index> (from PDIF)
.br
The index passed to \*BPDIF\fP may not have derivative operators in
it; the index is implicitly preceded by a `|' to indicate that a
partial derivative is being taken.
.sp 1
.ne 3
.ti 0
ERROR: free indice: <indice> <name> (from MAPINDEX)
.br
The indice <indice>, in the index of the object <name> does not
match an indice in the output index, and is not a contraction indice. 
.sp 1
.ne 3
.ti 0
WARNING: garbage collector garb.exe missing (from GARB)
.br
The external garbage collector is not in the current working directory. The
garbage collection process aborts.
.sp 1
.ne 3
.ti 0
ERROR: improper blocks for hermitian symmetry: <symmetry> (from CHKSYM)
.br
A block of the hermitian symmetry <symmetry> does not consist of
an undotted-dotted index pair. 
.sp 1
.ne 3
.ti 0
ERROR: improper contraction:  <index> <indice> (from CONTRACT)
.br
A contraction is implied over two indices which are either not of 
the same type; or, if \*BEXTENDEDSUM\fP is FALSE, are both covariant or 
contravariant. The offending indice is <indice> and the problem occurs 
in the combined index <index>.
.sp 1
.ne 3
.ti 0
ERROR: improper structure for hermitian symmetry: <symmetry> (from CHKSYM)
.br
The symmetry intended to be hermitian is not composed of spinor
dotted-spinor pairs.
.sp 1
.ne 3
.ti 0
ERROR: improper symmetry: <symmetry> (from CHKSYM)
.br
A CONCOV sublist for a block of the independent symmetry 
<symmetry> is different from the remaining sublists.
.sp 1
.ne 3
.ti 0
ERROR: inconsistent indices: <value> <expression> (from CHKCONCOV)
.br
The net \*BCONCOV\fP list of <value> does not match the \*BCONCOV\fP lists of 
other terms of the input expression.
.sp 1
.ne 3
.ti 0
ERROR: index wrong length: <name> <index> (from RDR)
.br
An index (<index>) with either too few or too many indices has
been applied to the object <name>. 
.sp 1
.ne 3
.ti 0
WARNING: indices do not match (from EVALTNSR1)
.br
The net \*BCONCOV\fP list of the input expression does not match the 
\*BCONCOV\fP list of the output object. This error only occurs when the 
output object was indexed before the assignment was made.
.sp 1
.ne 3
.ti 0
ERROR: input name required (from <function>)
.br
A required input to the function <function> has been omitted. The
input value is FALSE, and cannot be used. 
.sp 1
.ne 3
.ti 0
ERROR: invalid index: <index> (from PDIF)
.br
The index passed to \*BPDIF\fP is not properly constructed; enclose
the index in square brackets.
.sp 1
.ne 3
.ti 0
ERROR: invalid line element (from METRIC)
.br
\*BMETRIC\fP requires that the line-element be a sum.
.sp 1
.ne 3
.ti 0
ERROR: invalid pointers for hermitian symmetry: <symmetry> (from CHKSYM)
.br
The pointers specified for a hermitian symmetry do not point to pairs
of dotted - undotted spinor indices.
.sp 1
.ne 3
.ti 0
ERROR: invalid symmetry: <symmetry> (from CHKSYM)
.br
A block size for an independent symmetry has been found which is smaller than
those previously seen. Independent symmetries should be ordered from smallest
to largest block size.
.sp 1
.ne 3
.ti 0
ERROR: metric does not exist: <n> (from GETMET)
.br
The metric of type <n> does not exist (n \(eq 1, 2, 3, 4).
.sp 1
.ne 3
.ti 0
WARNING: missing conjugate for <name> being created.
.br
The conjugate object for the spinor <name> is missing. It will be re-created by
the system.
.sp 1
.ne 3
.ti 0
WARNING: missing differential: d(<expression>) (from d)
.br
The total derivative of <expression> is zero, this term will disappear from
the line-element.
.sp 1
.ne 3
.ti 0
ERROR: missing inverse: <name>#INV (from GETMET)
.br
There is no inverse for the metric <name>.
.sp 1
.ne 3
.ti 0
WARNING: no such offspring for: <object> (from RDR)
.br
A request for a specific element of an offspring object has
failed, because the object does not exist. 
.sp 1
.ne 3
.ti 0
ERROR: non-atomic indice: <name> <index> (from IPRSE)
.br
The index <index> to the object <name> contains an indice which is 
not an atom and which is not a shifted indice.
.sp 1
.ne 3
.ti 0
ERROR: object must have two indices: <name> (from <function>)
.br
The function <function> (either \*BDET\fP, \*BDETERM\fP or
\*BCOFACTOR\fP) will only accept a rank-2 object as input.
.sp 1
.ne 3
.ti 0
ERROR: offload file corrupted: <name> (from GETVAL or ONLOAD)
.br
The pointers for the object <name> do not point to valid elements in the
offload file.
.sp 1
.ne 3
.ti 0
WARNING: offload file error <name> (from PUTVAL or OFFLOAD)
.br
The offload file for <name> cannot be opened.
.sp 1
.ne 3
.ti 0
WARNING offload file open error <name> <file> (from GETVAL or ONLOAD) 
.br
The offload file specified for the object <name> cannot be opened.
.sp 1
.ne 3
.ti 0
ERROR: output <name> is protected (from COPY)
.br
\*BCOPY\fP has failed to copy to the name <name> because <name> is 
indexed and is protected.
.sp 1
.ne 3
.ti 0
ERROR: overlapping blocks: <symmetry> (from CHKSYM)
.br
At least one block in the independent symmetry <symmetry> overlaps 
another.
.sp 1
.ne 3
.ti 0
ERROR: pointer out of order: <symmetry> (from CHKSYM)
.br
The pointers in the independent symmetry <symmetry> are not in 
ascending order.
.sp 1
.ne 3
.ti 0
WARNING: singular matrix: <name> (from <function>)
.br
The rank-2 object <name> is singular. This error comes from either 
\*BDET\fP or \*BDETERM\fP and will usually be followed
by a muSIMP ZERODIVIDE error.
.sp 1
.ne 3
.ti 0
WARNING: subscript out of bounds: <object>
.br
An integer indice in the index of <object> is not within the 
allowed run of indices. The object is replaced with 0.
.sp 1
.ne 3
.ti 0
ERROR: symmetry too long: <symmetry> (from CHKSYM)
.br
The independent symmetry <symmetry> refers to an indice whose 
position is incompatible with the rank of the object.
.sp 1
.ne 3
.ti 0
ERROR: too few pointers: <symmetry> (from CHKSYM)
.br
The independent symmetry <symmetry> has fewer than two pointers.
.sp 1
.ne 3
.ti 0
ERROR: too many contraction indices:  <index> <indice> (from CONTRACT)
.br
A simultaneous contraction is implied over more than two indices.
The offending indice is <indice> and the problem occurs in the
combined index <index>.
.sp 1
.ne 3
.ti 0
ERROR: unable to shift derivative index
.br
A derivative index is not part of the object and cannot be
shifted. If the index must be raised, an explicit contraction with a
metric should be provided. 
.sp 1
.ne 3
.ti 0
WARNING: unmatched coordinates: <name>, <expression> (from PROCESSVALUE)
.br
The object <name> is defined in the coordinates <coords>, which
are different from the current coordinates as stored in \*BCOORDS\fP.
.sp 1
.ne 3
.ti 0
WARNING: <file> exists and is not in vmem format (from CHKOFF)
.br
The user has attempted to use the file <file> as a virtual memory file,
but <file> does not have the correct format. Use another file.
.sp 1
.ne 3
.ti 0
WARNING: <name> cannot be assigned (from IAS)
.br
The input <name> to \*BIAS\fP is either not an indexed object or is 
write-protected.
.sp 1
.ne 3
.ti 0
ERROR: <name> does not have metric structure. (from METRIC)
.br
The object <name> passed to \*BMETRIC\fP does not have '(-1 -1) as its
concov parameter. \*BMETRIC\fP wants a covariant rank-2 object to
convert into a metric.
.sp 1
.ne 3
.ti 0
ERROR: <name> is already defined (from NEWNME)
.br
A call to a general relativity routine has specified an output name 
<name> which is already indexed. Change the default name for the 
function, or delete the current definition of <name>, or specify a 
different input name.
.sp 1
.ne 3
.ti 0
WARNING: <name> is write-protected (from WRITETNSR or EVALTNSR1)
.br
The object <name> is write-protected and cannot have new elements written
to it.
